using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

using Syncfusion.IO;
using Syncfusion.Windows.Forms.Edit;
using Syncfusion.Windows.Forms.Edit.Enums;
using Syncfusion.Windows.Forms.Edit.Dialogs;
using Syncfusion.Windows.Forms.Edit.Implementation.Config;
using Syncfusion.Windows.Forms.Edit.Interfaces;
using Syncfusion.Windows.Forms.Edit.Implementation.IO;
using Syncfusion.Windows.Forms.Edit.Implementation.Formatting;
using Syncfusion.Windows.Forms.Edit.Implementation.Parser;
using Syncfusion.Windows.Forms.Edit.Implementation;


namespace Intellisense
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Edit.EditControl editControl1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.MainMenu mainMenu1;
        private System.ComponentModel.IContainer components;
        private MenuItem menuItem6;
		private string dropper;
    	public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            this.editControl1.Configurator.Open("..//..//ApplixEditConfig.xml");
            this.editControl1.ApplyConfiguration("TM1Rule");
            this.editControl1.ShowSelectionMargin = false;
            this.editControl1.LoadFile("..//..//rent analysis.RUX");
            this.editControl1.AutoCompleteSingleLexem = true;
           
          	//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            Syncfusion.Windows.Forms.Edit.Implementation.Config.Config config1 = new Syncfusion.Windows.Forms.Edit.Implementation.Config.Config();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.editControl1 = new Syncfusion.Windows.Forms.Edit.EditControl();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            ((System.ComponentModel.ISupportInitialize)(this.editControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // editControl1
            // 
            this.editControl1.Configurator = config1;
            this.editControl1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.editControl1.DropAllFiles = false;
            this.editControl1.FileExtensions = new string[] {
        ".cs",
        ".htm",
        ".html",
        ".java",
        ".js",
        ".pas",
        ".sql",
        ".vb",
        ".vbs",
        ".xml"};
            this.editControl1.Location = new System.Drawing.Point(0, 0);
            this.editControl1.Name = "editControl1";
            this.editControl1.SaveOnClose = false;
            this.editControl1.Size = new System.Drawing.Size(584, 438);
            this.editControl1.StatusBarSettings.StatusPanel.MinWidth = 70;
            this.editControl1.StatusBarSettings.TextPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
            this.editControl1.TabIndex = 0;
            this.editControl1.Text = "";
            this.editControl1.WordWrap = true;
            this.editControl1.ContextChoiceOpen += new Syncfusion.Windows.Forms.Edit.ContextChoiceEventHandler(this.editControl1_ContextChoiceOpen);
            this.editControl1.ContextChoiceSelectedTextInsert += new Syncfusion.Windows.Forms.Edit.ContextChoiceTextInsertEventHandler(this.editControl1_ContextChoiceSelectedTextInsert);
            this.editControl1.ContextChoiceClose += new Syncfusion.Windows.Forms.Edit.ContextChoiceCloseEventHandler(this.editControl1_ContextChoiceClose);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            this.imageList1.Images.SetKeyName(5, "");
            this.imageList1.Images.SetKeyName(6, "");
            this.imageList1.Images.SetKeyName(7, "");
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem6});
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 0;
            this.menuItem6.Text = "ShowFormatsDialog";
            this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(584, 438);
            this.Controls.Add(this.editControl1);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "Form1";
            ((System.ComponentModel.ISupportInitialize)(this.editControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void editControl1_ContextChoiceOpen(Syncfusion.Windows.Forms.Edit.Interfaces.IContextChoiceController controller)
		{
            if (controller.Dropper != null)
            {
                dropper = controller.Dropper.Text;

                controller.UseAutocomplete = true;

                controller.Items.Add("ABS");
                controller.Items.Add("ACOS");
                controller.Items.Add("ASIN");
                controller.Items.Add("ATAN");
                controller.Items.Add("ATAN2");
                controller.Items.Add("CEILING");
                controller.Items.Add("COS");
                controller.Items.Add("COSH");
                controller.Items.Add("EXP");
                controller.Items.Add("FLOOR");
                controller.Items.Add("LOG");
                controller.Items.Add("MAX");
                controller.Items.Add("MIN");
                controller.Items.Add("POW");
                controller.Items.Add("ROUND");
                controller.Items.Add("SIN");
                controller.Items.Add("SQRT");
                controller.Items.Add("TAN");
                controller.Items.Add("TANH");
                controller.Items.Add("TRUNCATE");

                if (controller.Dropper.Config.ID == 1000)
                {
                    controller.Items.Clear();
                    controller.Items.Add("MAX");
                    controller.Items.Add("MIN");
                    controller.Items.Add("POW");
                    controller.Items.Add("ROUND");
                }
                if (controller.Dropper.Config.ID == 1001)
                {
                    controller.Items.Clear();
                    controller.Items.Add("COS");
                    controller.Items.Add("COSH");
                    controller.Items.Add("EXP");
                    controller.Items.Add("FLOOR");
                }
            }
            else
            {
            }
             }

		private void editControl1_ContextChoiceSelectedTextInsert(Syncfusion.Windows.Forms.Edit.Interfaces.IContextChoiceController sender, Syncfusion.Windows.Forms.Edit.ContextChoiceTextInsertEventArgs e)
		{
            this.editControl1.DeleteText(this.editControl1.Parser.GetCoordinatePoint(this.editControl1.CurrentLine,this.editControl1.GetCurrentWordColumn()),this.editControl1.Parser.GetCoordinatePoint(this.editControl1.CurrentLine,this.editControl1.GetCurrentWordColumn()+this.editControl1.GetCurrentWord().Length));
			this.editControl1.InsertText(this.editControl1.CurrentLine,this.editControl1.CurrentColumn,e.SelectedItem.Text);
			e.Cancel=true;
		}

		
        private void editControl1_ContextChoiceClose(Syncfusion.Windows.Forms.Edit.Interfaces.IContextChoiceController controller, System.Windows.Forms.DialogResult dialogresult)
        {
            controller.Items.Clear();
        }


        private void menuItem6_Click(object sender, EventArgs e)
        {
            FormatsDialog fd = new FormatsDialog();
            fd.EditControl = this.editControl1;
            fd.ShowDialog();
        }

	}
}